<?php 

ini_set('display_errors', '0');

//error_reporting(E_ALL & ~E_NOTICE);
include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/error_reporting.php");
include_once(realpath(dirname(__FILE__)) . "/Shoppingflux.class.php");
include_once(realpath(dirname(__FILE__)) . "/config.php");



header("Content-type: application/xml");
// fonction servant à supprimer les caractères spéciaux (utilisée pour les balises)


function filter($chaine)
{
	if(!mb_check_encoding($chaine, 'UTF-8'))
        {
            $chaine = utf8_encode($chaine);
        }
	
	$chaine = mb_ereg_replace('[ ]', 'thisisanespace', $chaine);
	setlocale(LC_ALL, 'fr_FR');

	$chaine = iconv('UTF-8', 'ASCII//TRANSLIT//IGNORE', $chaine);
	$chaine = preg_replace('#[^0-9a-z]+#i', '', $chaine);

	$chaine = mb_ereg_replace('thisisanespace', '_', $chaine);
	
	$chaine = str_replace('__', '_', $chaine);

	return $chaine;
}



function protectXML($in)
{

	$in = strip_tags($in);
	$string=$in;
	
        $string = html_entity_decode($string, ENT_QUOTES);
        if(!mb_check_encoding($string, 'UTF-8'))
        {
            $string = utf8_encode($string);
        }



        $caracteres_non_codes=array('Œ', 'œ', 'Ÿ', '–', '—', '‘', '’', '‚', '“', '”', '„', '†', '‡', '•', '…', '‰', '‹', '›', '€', '™');
        $caracteres_codes=array('&OElig;', '&oelig;', '&Yuml;', '&ndash;', '&mdash;', '&lsquo;', '&rsquo;', '&sbquo;', '&ldquo;', '&rdquo;', '&bdquo;', '&dagger;', '&Dagger;', '&bull;', '&hellip;', '&permil;', '&lsaquo;', '&rsaquo;', '&euro;', '&trade;');

        $string = str_replace($caracteres_codes, $caracteres_non_codes, $string);

        return str_replace("&rsquo;","'",$string);
        
}

$xml = "<?xml version= '1.0' encoding= 'UTF-8' ?>";
$xml .= "<produits>";
$produit = new Produit();

$query = "select * from modules where nom='codeBarre' and actif=1";
$result=mysql_query($query);

$codeBarreActive = false;
if(mysql_num_rows($result)!=0)
{
	$codeBarreActive = true;
}

 
$query = "select valeur from variable where nom='urlsite'";
$result = mysql_query($query);

$data = mysql_fetch_object($result);
$urlSite = $data->valeur;

$query = "         SELECT  p.id AS idproduit, p.poids, p.ref AS refProd, p.ecotaxe, p.prix, p.prix2, p.stock,
                                pd.titre, pd.chapo, pd.description, 
                                rd.titre AS titrerub,
                                r.id AS idrub
                        FROM ". Produit::TABLE ." p
                            LEFT JOIN " . Produitdesc::TABLE . " pd 
                                ON pd.produit = p.id AND pd.lang = " . ID_LANG . "
                            LEFT JOIN " . Rubrique::TABLE . " r
                                ON r.id = p.rubrique 
                            LEFT JOIN " . Rubriquedesc::TABLE . " rd
                                ON rd.rubrique = p.rubrique AND rd.lang = " . ID_LANG . "
                        WHERE p.ligne=1 and rd.lang=".ID_LANG."
                                ";	



$result = mysql_query($query);

while ($data = mysql_fetch_object($result))
{
    //URL de la fiche Produit
    $produitdesc = new Produitdesc($data->idproduit, 1);
    $ficheprod = $produitdesc->getUrl();


    //Marque    
    if (!empty($idcaracmarque))
        $marque = $data->marque;

    else
        $marque = $nommarque;


    //Gestion des stocks
    if ($verifstock->valeur)
    {
        $stock = $data->stock;

        if ($stock > 0)
            $stockstring = "oui";
        else
            $stockstring = "non";
    }
    else
    {
        $stock = "";
        $stockstring = "oui";
    }


    //GESTION DES PRIX ET DES PROMOTIONS
    if (($data->prix2 > 0) && ($data->prix2 < $data->prix))
    {
        $prixttc = $data->prix2;
        $prixold = $data->prix;
        $remise = $data->prix - $data->prix2;
        $txtremise = (1 - $prixttc / $prixold ) * 100;
        $txtremise = number_format($txtremise, 0) . "%";
    }
    else
    {
        $prixttc = $data->prix;
        $prixold = "";
        $remise = "";
        $txtremise = "";
    }


    //CREATION DU <produit>;
    $xml .= "<produit>";
    $xml .= "<id>$data->idproduit</id>";
    
    
    $rub2 = protectXML($data->titrerub);	// on met la rubrique actuelle
    // on va ensuite rajouter le reste du chemin
    $monId = $data->idrub;
    $k=0;
    
    // on récupère toutes les rubriques/sous-rubriques
    while(1)
    {
		
		$queryRub = "SELECT r.id, r.parent AS parentR, rd.titre as titrePar from rubrique AS r, rubriquedesc AS rd where r.id=".$monId." and r.parent=rd.rubrique AND lang=".ID_LANG."";
		$resultRub = mysql_query($queryRub);
		$rubriqueResult = mysql_fetch_object($resultRub);
		
		// s'il n'y a plus de rubrique, alors on avance
		if($rubriqueResult==null)
		{
			break;
		}
		
		
		// si on est pas sorti de la boucle, alors on complète le chemin
		$rub2 = protectXML($rubriqueResult->titrePar).">".$rub2;
		$monId = $rubriqueResult->parentR;
	}
    
	
    $stock = $data->stock;
    
    
    $rub2=protectXML($rub2);
    $xml .= "<rayon>$rub2</rayon>";
    $xml .= "<nom>".protectXML($data->titre)."</nom>";	// au lieu de <nom-du-produit>
    $xml .= "<description-courte>" . protectXML(strip_tags($data->chapo)) . "</description-courte>";
    $xml .= "<description>" . protectXML(strip_tags($data->description)) . "</description>";
    $xml .= "<quantite>$stock</quantite>";
    $xml .= "<en-stock>$stockstring</en-stock>";
    $xml .= "<url>$ficheprod</url>";

	$imageTab = new Image();

    //URL DES IMAGES
    $query_img = "  SELECT fichier
                    FROM " .Image::TABLE. " WHERE produit=" . $data->idproduit . "
                    ORDER by classement asc
                    LIMIT 3";

    $result_img = mysql_query($query_img, $produit->link);

    $i = 1;
    
    $xml .= "<images>";
    while (($lesImg = mysql_fetch_object($result_img)) || ($i < 4))
    {
        if (isset($lesImg->fichier))
        {
		   	$lien = Variable::lire("urlsite") . "/" . "client/gfx/photos/produit/" . $lesImg->fichier;
        }
        $xml .= "<image>" . ($lien ? : '') . "</image>";

        $i++;
    }
    $xml .= "</images>";



    //GESTION DES RUBRIQUES ET SOUS RUBRIQUES 
    $rubd = new Rubriquedesc();
    $rub = new Rubrique();

	 if (!$rubd->charger($data->idrub, ID_LANG))
    {
        $cat = "";
        $scat = "";
        $sscat = "";
        $liencat = "";
        $sliencat = "";
        $ssliencat = "";
    }
    else
    {
        $cat = $rubd->titre;
        $liencat = $rubd->getUrl();
        $rub->charger($rubd->rubrique);

        if (!$rubd->charger($rub->parent, ID_LANG))
        {
            $scat = "";
            $sscat = "";
            $sliencat = "";
            $ssliencat = "";
        }
        else
        {
            $scat = $rubd->titre;
            $sliencat = $rubd->getUrl();
            $rub->charger($rubd->rubrique);

            if (!$rubd->charger($rub->parent, ID_LANG))
            {
                $sscat = "";
                $ssliencat = "";
            }
            else
            {
                $sscat = $rubd->titre;
                $ssliencat = $rubd->getUrl();
            }
        }
    }
    
    if($sscat!="")
    {
		$temp = $cat;
		$cat = $sscat;
		$sscat = $temp;
	}


    $xml .= "<categorie>".protectXML($cat)."</categorie>";
    $xml .= "<sous-categorie>".protectXML($scat)."</sous-categorie>";
    $xml .= "<sous-sous-categorie>".protectXML($sscat)."</sous-sous-categorie>";
    $xml .= "<prix>$prixttc</prix>";
    $xml .= "<prix-barre>$prixold</prix-barre>";
    $xml .= "<montant-de-la-remise>$remise</montant-de-la-remise>";
    $xml .= "<pourcentage-de-remise>$txtremise</pourcentage-de-remise>";
    $xml .="<poids>".$data->poids."</poids>";
    $xml .= "<SKU>$data->idproduit</SKU>";
    $xml .= "<ecotaxe>$data->ecotaxe</ecotaxe>";
    $xml .= "<url_categorie>$liencat</url_categorie>";
    $xml .= "<url_sous-categorie>$sliencat</url_sous-categorie>";
    $xml .= "<url_sous-sous-categorie>$ssliencat</url_sous-sous-categorie>";
    
    
    // le plugin codeBarre doit être rempli pour que le champ EAN soit rempli
    $eanProduit = "";
    
    // si le plugin code barre est activé, alors on affiche le code EAN
    if($codeBarreActive)
    {
		$query_ean = "select ean from codeBarre_produit where produit_id=".$data->idproduit."";
		$result_ean = mysql_query($query_ean, $produit->link);
		
		// un while car il peut ne pas y avoir de résultats, mais sinon il n'y en a qu'un qui sort
		while($row = mysql_fetch_object($result_ean)){
			$eanProduit = $row->ean;
		}
		
		
		$xml .= "<EAN>$eanProduit</EAN>";
	}

	
	//GESTION DES CARACTERISTIQUES
	$xml .= "<caracteristiques>";
	$xml .= "<ref-marchand>$data->refProd</ref-marchand>";
	$monFournisseur="";
	
	$queryCaracValeur = "SELECT * FROM caracval WHERE produit=" . $data->idproduit;
	$resultCaracValeur = mysql_query($queryCaracValeur, $produit->link);
	
	while ($dataCaracValeur = mysql_fetch_object($resultCaracValeur))
	{		
		if($dataCaracValeur != null)
		{
			//on vérifie si la caractéristique est cochée dans la table caracteristiques_flux
			$queryCaracTitre = "SELECT * FROM caracteristiquedesc, caracteristiques_flux WHERE caracteristique=" . $dataCaracValeur->caracteristique." AND idCaracteristique=" . $dataCaracValeur->caracteristique." AND active=1 AND lang=".ID_LANG;
			$resultCaracTitre = mysql_query($queryCaracTitre, $produit->link);
			$dataCaracTitre = mysql_fetch_object($resultCaracTitre);

			
			if($dataCaracTitre != null)
			{
			
				//si caracdisp = 0 alors on charge la valeur sinon on charge caracdisp
				$caracdisp = $dataCaracValeur->caracdisp;
				
				
				$valeurCarac = $dataCaracValeur->valeur;	
				
				if($caracdisp != 0)
				{
					$queryCaracDisp = "SELECT * FROM caracdispdesc WHERE caracdisp=" . $caracdisp ." AND lang=".ID_LANG;
					$resultCaracDisp = mysql_query($queryCaracDisp, $produit->link);
					$dataCaracDisp = mysql_fetch_object($resultCaracDisp);
					
					if($dataCaracDisp != null)
					{
						$valeurCarac = $dataCaracDisp->titre;
					}
				}
				
				$nomCarac = $dataCaracTitre->titre;
				
				$nomCarac = filter($nomCarac);
				
				if($nomCarac=="ref_fournisseur")
					$monFournisseur=protectXML($valeurCarac);
				else
					$xml .= "<".$nomCarac.">".protectXML($valeurCarac)."</".$nomCarac.">";
			}
		}
	}
	
	$xml .= "</caracteristiques>";
	$xml .= "<ref-fournisseur>$monFournisseur</ref-fournisseur>";
	
	
	//GESTION DES DECLINAISONS
	$xml .= "<declinaisons>";

	$queryCaracDecli = "SELECT * FROM stock WHERE produit=" . $data->idproduit." and declidisp not in (select declidisp from exdecprod where produit=" . $data->idproduit.")";
	$resultCaracDecli = mysql_query($queryCaracDecli, $produit->link);

	while ($dataCaracDecli = mysql_fetch_object($resultCaracDecli))
	{		
		if($dataCaracDecli != null)
		{
		
			$xml .= "<declinaison>";
		
			$xml .= "<id>";
			$xml .= $dataCaracDecli->declidisp;	// ils concatènent eux-mêmes
			$xml .= "</id>";
			
			
			// on récupère l'EAN de la déclinaison courante si le plugin code barre est activé
			if($codeBarreActive)
			{
				$query_ean = "select id, ean, declidisp from codeBarre_decli_produit where produit_id='".$data->idproduit."' and declidisp='".$dataCaracDecli->declidisp."'";
				$result_ean = mysql_query($query_ean, $produit->link);
				$ean_decli = "";
				
				while($rowEAN = mysql_fetch_object($result_ean)){
					// un while car il peut ne pas y avoir de résultats, mais sinon il n'y en a qu'un qui sort	
					$eanDecli = $rowEAN->ean;
				}
			
			
				$xml .= "<EAN>$eanDecli</EAN>";
			}
			
			
			$xml .= "<quantite>";
			$xml .= $dataCaracDecli->valeur;
			$xml .= "</quantite>";
			
			$xml .= "<prix>";
			
			//si le prix avec réduction est égal à 0 on prend le prix sans réduction
			if($data->prix2 == 0)
				$prix2 = $data->prix + $dataCaracDecli->surplus;
			else $prix2 = $data->prix2 + $dataCaracDecli->surplus;
			
			$xml .= $prix2;
			$xml .= "</prix>";
			
			$xml .= "<prix-barre>";
			$xml .= $data->prix + $dataCaracDecli->surplus;
			$xml .= "</prix-barre>";
			
			
			$xml .= "<images>";
			
			$queryImage = "SELECT * FROM image WHERE produit=".$data->idproduit;
			$resultImage = mysql_query($queryImage, $produit->link);
			
			while($dataImage = mysql_fetch_object($resultImage))
			{
				if($dataImage != null)
				{
					$lien = Variable::lire("urlsite") . "/" . "client/gfx/photos/produit/" . $dataImage->fichier;
					$xml .= "<image>".$lien."</image>";
				}
			}

			$xml .= "</images>";
			
			
			$xml .= "<attributs>";
			
			$queryAttributsValeurs = "SELECT * FROM declidisp, declidispdesc WHERE declidispdesc.declidisp=".$dataCaracDecli->declidisp." AND declidisp.id=".$dataCaracDecli->declidisp." AND declidispdesc.lang=".ID_LANG;
			$resultAttributsValeurs = mysql_query($queryAttributsValeurs, $produit->link);
			
			
			while($dataAttributsValeur = mysql_fetch_object($resultAttributsValeurs))
			{
				if($dataAttributsValeur != null)
				{
					$queryAttributsTitre = "SELECT * FROM declinaisondesc WHERE declinaison=".$dataAttributsValeur->declinaison." AND lang=".ID_LANG;
					$resultAttributsTitre = mysql_query($queryAttributsTitre, $produit->link);
					$dataAttributsTitre = mysql_fetch_object($resultAttributsTitre);
					
					$attrTitre = $dataAttributsTitre->titre;
					$attrValeur = $dataAttributsValeur->titre;
					
					$attrTitre = filter($attrTitre);
					
					
					$xml .= "<".$attrTitre.">".protectXML($attrValeur)."</".$attrTitre.">";
				}
			}
			
			$xml .= "</attributs>";

			
			$xml .= "</declinaison>";
		}
	}
	
	$xml .= "</declinaisons>";
	
	
    $xml .= "</produit>";
}
$xml .= "</produits>";

	
	// gérer les autres remplacements
	
	/*$fic = fopen("fichierGenere.xml","w");
	fwrite($fic, $xml);
	fclose($fic);*/


echo $xml;
?>
